#define _CRT_SECURE_NO_WARNINGS
#define _WINSOCK_DEPRECATED_NO_WARNINGS
#pragma comment (lib, "Ws2_32.lib")

#include <stdio.h>
#include <WinSock2.h>
#include <memory.h>

SOCKET createClientSocket()
{
	//inicializacia kniznice WinSock
	WSADATA wsaData;
	if (WSAStartup(MAKEWORD(2, 2), &wsaData) != NO_ERROR)
	{
		printf("Error in WSA startup\n");
		return INVALID_SOCKET;
	}

	//vytvorenie socketu
	SOCKET clientSocket = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
	if (clientSocket == INVALID_SOCKET)
	{
		printf("Error creating socket\n");
		WSACleanup();
		return INVALID_SOCKET;
	}

	return clientSocket;
}

int main()
{
	char address[16];
	printf("Enter server address: ");
	scanf("%s", address);

	int port;
	printf("Enter server port: ");
	scanf("%d", &port);

	//vytvorenie klientskeho socketu
	SOCKET clientSocket = createClientSocket();
	if (clientSocket == INVALID_SOCKET)
	{
		return -1;
	}

	sockaddr_in serverAddr;
	memset(&serverAddr, 0, sizeof(serverAddr));
	serverAddr.sin_family = AF_INET;
	serverAddr.sin_addr.s_addr = inet_addr(address);
	serverAddr.sin_port = htons(port);
	int serverAddrSize = sizeof(serverAddr);

	char command = 1;
	char recvBuff[256];

	char fileName[256];
	printf("Enter file name: ");
	scanf("%s", fileName);

	FILE* pFile = fopen(fileName, "w");
	if (pFile)
	{
		do
		{
			if (sendto(clientSocket, &command, 1, 0, (sockaddr*)&serverAddr, serverAddrSize) == SOCKET_ERROR)
			{
				printf("Error sending data\n");
				closesocket(clientSocket);
				WSACleanup();
				return -1;
			}

			if (command == 1)
			{
				int result = recvfrom(clientSocket, recvBuff, 256, 0, (sockaddr*)&serverAddr, &serverAddrSize);
				if (result < 0)
				{
					printf("Error receiving data\n");
					closesocket(clientSocket);
					WSACleanup();
					return -1;
				}
				else if (result > 0)
				{
					fprintf(pFile, "%s", recvBuff);
				}
				else
				{
					command = 0;
					sendto(clientSocket, &command, 1, 0, (sockaddr*)&serverAddr, serverAddrSize);
				}
			}
		} while (command == 1);

		fclose(pFile);
	}

	closesocket(clientSocket);
	//ukoncenie pouzivania kniznice WinSock
	WSACleanup();

	return 0;
}

