#define _CRT_SECURE_NO_WARNINGS
#define _WINSOCK_DEPRECATED_NO_WARNINGS
#pragma comment (lib, "Ws2_32.lib")

#include <stdio.h>
#include <WinSock2.h>
#include <memory.h>

SOCKET createListenSocket(int port)
{
	//inicializacia kniznice WinSock
	WSADATA wsaData;
	if (WSAStartup(MAKEWORD(2, 2), &wsaData) != NO_ERROR)
	{
		printf("Error in WSA startup\n");
		return INVALID_SOCKET;
	}

	//vytvorenie socketu pre prijimanie spojeni
	SOCKET listenSocket = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
	if (listenSocket == INVALID_SOCKET)
	{
		printf("Error creating socket\n");
		WSACleanup();
		return INVALID_SOCKET;
	}

	//nastavenie portu servera
	sockaddr_in socketAddr;
	memset(&socketAddr, 0, sizeof(socketAddr));
	socketAddr.sin_family = AF_INET;
	socketAddr.sin_addr.s_addr = inet_addr("127.0.0.1");
	socketAddr.sin_port = htons(port);

	//priradenie portu pre socket
	if (bind(listenSocket, (sockaddr*)&socketAddr, sizeof(socketAddr)) == SOCKET_ERROR)
	{
		printf("Error binding socket\n");
		closesocket(listenSocket);
		WSACleanup();
		return INVALID_SOCKET;
	}

	return listenSocket;
}

int main()
{
	int port;
	printf("Enter UDP port: ");
	scanf("%d", &port);

	//vytvorenie servera
	SOCKET listenSocket = createListenSocket(port);
	if (listenSocket == INVALID_SOCKET)
	{
		return -1;
	}

	printf("UDP socket created\n");

	int result;

	sockaddr_in clientAddr;
	int clientAddrSize = sizeof(clientAddr);

	char fileName[256];
	printf("Enter file name: ");
	scanf("%s", fileName);

	FILE* pFile = fopen(fileName, "r");
	if (pFile)
	{
		char command;

		do
		{
			result = recvfrom(listenSocket, &command, 1, 0, (sockaddr*)&clientAddr, &clientAddrSize);
			if (result == SOCKET_ERROR)
			{
				printf("Receive failed\n");
				closesocket(listenSocket);
				WSACleanup();
				return -1;
			}

			if (command == 1)
			{
				char line[256];
				char* linePtr = fgets(line, 256, pFile);
				if (sendto(listenSocket, line, linePtr ? strlen(line) + 1 : 0, 0, (sockaddr*)&clientAddr, clientAddrSize) == SOCKET_ERROR)
				{
					printf("Send failed\n");
					closesocket(listenSocket);
					WSACleanup();
					return -1;
				}
			}
		} while (command != 0);

		fclose(pFile);
	}
	
	//zatvorenie socketu
	closesocket(listenSocket);
	//ukoncenie pouzivania kniznice WinSock
	WSACleanup();

	return 0;
}


